#include "FastLED.h"

// How many leds in your strip?
#define NUM_LEDS 64
#define BRIGHTNESS 10
// For led chips like Neopixels, which have a data line, ground, and power, you just
// need to define DATA_PIN.  For led chipsets that are SPI based (four wires - data, clock,
// ground, and power), like the LPD8806 define both DATA_PIN and CLOCK_PIN
#define DATA_PIN 3
#define CLOCK_PIN 13
//#define NUM_COLOR 8
#define DELAY 200

// Define the array of leds

CRGB leds[NUM_LEDS];

void setup() { 
      // Uncomment/edit one of the following lines for your leds arrangement.
      // FastLED.addLeds<TM1803, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<TM1804, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<TM1809, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<WS2811, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<WS2812, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<WS2812B, DATA_PIN, RGB>(leds, NUM_LEDS);
  	  FastLED.addLeds<NEOPIXEL, DATA_PIN>(leds, NUM_LEDS);
      // FastLED.addLeds<APA104, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<UCS1903, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<UCS1903B, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<GW6205, DATA_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<GW6205_400, DATA_PIN, RGB>(leds, NUM_LEDS);
      
      // FastLED.addLeds<WS2801, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<SM16716, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<LPD8806, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<P9813, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<APA102, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<DOTSTAR, RGB>(leds, NUM_LEDS);

      // FastLED.addLeds<WS2801, DATA_PIN, CLOCK_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<SM16716, DATA_PIN, CLOCK_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<LPD8806, DATA_PIN, CLOCK_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<P9813, DATA_PIN, CLOCK_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<APA102, DATA_PIN, CLOCK_PIN, RGB>(leds, NUM_LEDS);
      // FastLED.addLeds<DOTSTAR, DATA_PIN, CLOCK_PIN, RGB>(leds, NUM_LEDS);
      
}

void loop() { 
  // Turn the LED on, then pause
  int count=0;
  int RGB_data[]={
    3,3,3,2,2,3,3,3,
    3,2,2,2,2,2,2,3,
    2,2,2,2,2,2,2,2,
    3,4,4,4,4,4,4,3,
    3,4,6,6,6,6,4,3,
    3,4,6,5,5,6,4,3,
    3,4,6,5,5,6,4,3,
    3,4,4,5,5,4,4,3
  };
  delay(DELAY*10);
  for (int j=0 ; j<8; j++){
    for(int i=0; i<8; i++){
      //count = addr(i,j);
      set_RGB(63-count,RGB_data[j*8+i]);
      FastLED.show();
      delay(DELAY);
      count++;
    }
  }
  delay(DELAY*10);
  for ( int k = 0; k <64; k++ ) {  
    leds[k]= CRGB(0,0,0);
    FastLED.show();
    delay(DELAY);
  }
}

int addr(int x,int y){
  int z = 0;
  if (y % 2 == 0) {
    z = (7-y)*8 + 7-x;
  }  else {
    z = (7-y)*8 + x; 
  }
  return z;
}

void set_RGB(int num, int col){
  switch (col){
     case 0:
      leds[num] = CRGB(0,0,0);// Black
      break;
     case 1:
      leds[num] = CRGB(0,0,BRIGHTNESS);// Blue
      break;
     case 2:
      leds[num] = CRGB(0,BRIGHTNESS,0);// Green
      break;
     case 3:
      leds[num] = CRGB(0,BRIGHTNESS,BRIGHTNESS);// Skyblue
      break;
     case 4:
      leds[num] = CRGB(BRIGHTNESS,0,0);// Red
      break;
     case 5:
      leds[num] = CRGB(BRIGHTNESS,0,BRIGHTNESS);// Pink
      break;
     case 6:
      leds[num] = CRGB(BRIGHTNESS,BRIGHTNESS,0);// Yellow
      break;
     case 7:
      leds[num] = CRGB(BRIGHTNESS,BRIGHTNESS,BRIGHTNESS);// White
      break;
    }
}

